#
# spec file for package ghc-auto
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name auto
Name:           ghc-%{pkg_name}
Version:        0.4.3.1
Release:        lp150.1.8
Summary:        Denotative, locally stateful programming DSL & platform
License:        MIT
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-MonadRandom-devel
BuildRequires:  ghc-base-orphans-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-cereal-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-profunctors-devel
BuildRequires:  ghc-random-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-semigroups-devel
BuildRequires:  ghc-transformers-devel

%description
(Up to date documentation is maintained at <https://mstksg.github.com/auto>)

Read the README first! <https://github.com/mstksg/auto/blob/master/README.md> ,
for motivating examples, and concrete explanations of things described here.

/auto/ is a Haskell DSL and platform providing declarative, compositional,
denotative semantics for discrete-step, locally stateful, interactive programs,
games, and automations, with implicitly derived serialization. It is suited for
any domain where either the input or the output can be described as a stream of
values: a stream of input events, output views, etc.

/auto/ works by providing a type that encapsulates "value stream transformers",
or locally stateful functions; by specifying your program as a (potentially
cyclic) graph of relationships between value streams, you create a way of
"declaring" a system based simply on static relationships between quantities.

Instead of a "state monad" type solution, where all functions have access to a
rigid global state, /auto/ works by specifying relationships which each exist
independently and on their own, without any global state.

A more fuller exposition is in the `README.md`, in this project directory and
also online at <https://github.com/mstksg/auto/blob/master/README.md>; you can
get started by reading the tutorial, which is also in this project directory in
the `tutorial` directory, and also incidentally online at
<https://github.com/mstksg/auto/blob/master/tutorial/tutorial.md>.
Also, check out the <https://github.com/mstksg/auto-examples auto-examples>
repository on github for plenty of real-world and toy examples to learn from;
I've also done a <http://blog.jle.im/entries/series/+all-about-auto blog
series> on this library, with examples and full tutorials!

Support available on freenode's #haskell-auto, #haskell-game, and also on the
github issue tracker for the source repository.

Import "Control.Auto" to begin!.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%doc LICENSE

%files devel -f %{name}-devel.files
%doc CHANGELOG.md README.md

%changelog
* Thu Aug  3 2017 psimons@suse.com
- Updated with latest spec-cleaner version 0.9.8-8-geadfbbf.
* Wed Jan 18 2017 psimons@suse.com
- Update to version 0.4.3.1 with cabal2obs.
* Sun Jul 10 2016 psimons@suse.com
- Update to version 0.4.3.0 revision 0 with cabal2obs.
